using System;
using System.Linq;

namespace _C__VODOPAD
{
    class Program
    {
        static void Main(string[] args)
        {
            int kolona, redova;
            string[] ulaz = Console.ReadLine().Split(' ');
            redova = int.Parse(ulaz[0]);
            kolona = int.Parse(ulaz[1]);
            int[][] data = new int[redova][];
            int[] izlaz = new int[kolona];
            izlaz = Enumerable.Repeat(1, kolona).ToArray();
            for (int i = 0; i < redova; i++)
            {
                string[] tempUlaz = Console.ReadLine().Split(' ');
                data[i] = new int[kolona];
                int leva = 0;
                int desna = kolona - 1;
                data[i] = Array.ConvertAll(tempUlaz, int.Parse);
                for (int v = 0; v < kolona; v++)
                {
                    int broj = data[i][v];
                    if (broj == 0)
                    {
                        if (v == leva)
                        {
                            int g = 1;
                            while (g < kolona && data[i][g] == 0)
                            {
                                g++;
                            }
                            izlaz[g] += izlaz[leva];
                            izlaz[leva] = 0;
                        }
                        else if (v == desna)
                        {
                            int g = kolona-1;

                            while (g > 0 && data[i][g] == 0)
                            {
                                g--;
                            }
                            izlaz[g] += izlaz[desna];
                            izlaz[desna] = 0;
                        }
                        else
                        {
                            int vrednostVode = izlaz[v];
                            izlaz[v] = 0;
                            int naObeStrane = vrednostVode / 2;
                            int naDesnuStranu = vrednostVode % 2;
                            int naLevuStranu = vrednostVode % 2;
                            if ((i+1) % 2 == 0)
                            {
                                naLevuStranu = 0;
                            }
                            else
                            {
                                naDesnuStranu = 0;
                            }
                            int g1 = v;
                            bool ima = true;
                            while (g1 <= kolona)
                            {
                                if (g1 == kolona)
                                {
                                    ima = false;
                                    break;
                                }
                                else if (data[i][g1] == 1)
                                {
                                    ima = true;
                                    break;
                                }
                                else
                                {
                                    g1++;
                                }
                            }
                            if (ima)
                            {
                                izlaz[g1] += naObeStrane + naDesnuStranu;
                            }
                            else
                            {
                                naLevuStranu += naDesnuStranu + naObeStrane;
                                ima = true;
                            }
                            int g2 = v;
                            while (g2 >= -1)
                            {
                                if (g2 == -1)
                                {
                                    ima = false;
                                    break;
                                }
                                else if (data[i][g2] == 1)
                                {
                                    ima = true;
                                    break;
                                }
                                else
                                {
                                    g2--;
                                }
                            }
                            if (ima)
                            {
                                izlaz[g2] += naObeStrane + naLevuStranu;
                            }
                            else
                            {
                                izlaz[g1] += naObeStrane + naLevuStranu;
                            }
                        }
                    }
                }
            }
            string izlazText = String.Join(" ", izlaz);
            Console.WriteLine(izlazText);
        }
    }
}